unit ShapeDesignerMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Menus, ComCtrls,
  ExtCtrls, PairSplitter, LCLIntf, StdCtrls, MyShape;

type

  { TFormMain }

  TFormMain = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MainMenu: TMainMenu;
    MenuItemFile: TMenuItem;
    MenuItemClose: TMenuItem;
    PairSplitterMain: TPairSplitter;
    PairSplitterSideLeft: TPairSplitterSide;
    PairSplitterSideRight: TPairSplitterSide;
    PanelLeft: TPanel;
    PanelRight: TPanel;
    ScrollBoxForShapes: TScrollBox;
    StatusBarMain: TStatusBar;
    TreeViewForShapes: TTreeView;
    procedure MenuItemCloseClick(Sender: TObject);
    procedure ScrollBoxForShapesDblClick(Sender: TObject);
    procedure ScrollBoxForShapesMouseMove(Sender: TObject);
    procedure TreeViewForShapesClick(Sender: TObject; Node: TTreeNode);
    procedure RemoveShape(Sender: TObject);
  private

  public

  end;

var
  FormMain:            TFormMain;

implementation

{$R *.lfm}

{ TFormMain }

procedure TFormMain.MenuItemCloseClick(Sender: TObject);
begin
  FormMain.Close;
end;

procedure TFormMain.ScrollBoxForShapesDblClick(Sender: TObject);
var
  NewMyShape: TMyShape;
  MousePos:   TPoint;
  x,y:        Integer;

begin
  MousePos := ScrollBoxForShapes.ScreenToClient(Mouse.CursorPos);
  x := MousePos.x;
  y := MousePos.y;

  NewMyShape := TMyShape.Create(Self);
  with NewMyShape do
  begin
    Parent       := ScrollBoxForShapes;
    Left         := x;
    Top          := y;
    Pen.Color    := clBlack;
    Width        := 20;
    Height       := 20;
    Brush.Color  := clRed;
    Visible      := True;
    CallBackFunc := @RemoveShape;
  end;

  TreeViewForShapes.Items.Add(nil, NewMyShape.Name);
end;

procedure TFormMain.RemoveShape(Sender: TObject);
var
  Node: TTreeNode;

begin
  Node := TreeViewForShapes.Items[0];

  while ( Node <> nil ) do
  begin
    if ( Node.Text = TMyShape(Sender).Name ) then
    begin
      Node.delete;
      break;
    end;
    Node := Node.GetNext;
  end;
  TreeViewForShapes.Repaint;
end;


procedure TFormMain.ScrollBoxForShapesMouseMove(Sender: TObject);
var
  MousePos: TPoint;
  x,y:      Integer;
begin
  MousePos := ScrollBoxForShapes.ScreenToClient(Mouse.CursorPos);
  x := MousePos.x;
  y := MousePos.y;

  StatusBarMain.SimpleText := 'x = ' + IntToStr(x) + ', y = ' + IntToStr(y);
end;

procedure TFormMain.TreeViewForShapesClick(Sender: TObject; Node: TTreeNode);
var
  OldMyShape: TMyShape;

begin
  if assigned(TreeViewForShapes.Selected) then
  begin
    Node := TreeViewForShapes.Selected;
    OldMyShape := self.FindComponent(Node.Text) as TMyShape;
    if assigned(OldMyShape) then
    begin
      OldMyShape.Free;
      (TreeViewForShapes.Selected).delete;
    end;
  end;
end;

end.

